package com.persagy.apm.diagnose.config;

import com.alibaba.fastjson.JSONArray;
import com.persagy.framework.tenant.mybatis.datasource.db.holder.SaasContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.TopicExchange;
import org.springframework.amqp.rabbit.connection.CorrelationData;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.UUID;

/**
 * 推送数据 消息
 */
@Slf4j
@Configuration
public class RabbitConfig {
    @Autowired
    private RabbitTemplate rabbitTemplate;
    /**
     * 交换机
     */
    private final String exchange = "exchange-msg-service";
    /**
     * 报警记录 路由键
     */
    private final String alarmDataRoutingKey = "alarm-data-routing-key";
    /**
     * 报警记录队列
     */
    private final String alarmDataQueue = "alarm-data-queue";

    /*@Bean
    public TopicExchange alarmServiceExchange() {
        return new TopicExchange(exchange);
    }
    @Bean
    public Queue alarmRecordQueue() {
        return new Queue(alarmDataQueue, true);
    }
    @Bean
    public Binding alarmRecordBinding() {
        return BindingBuilder.bind(alarmRecordQueue()).to(alarmServiceExchange()).with(alarmDataRoutingKey);
    }*/

    public void sendMsg(JSONArray contentArray) {
        CorrelationData correlationId = new CorrelationData(UUID.randomUUID().toString());
        //把消息放入routingKey_indicator对应的队列当中去，对应的是队列QUEUE_indicator
        String routingKey = SaasContext.getContextGroupCode()+"-"+alarmDataRoutingKey;
        rabbitTemplate.convertAndSend(exchange, routingKey, contentArray, correlationId);
    }

}
