package com.persagy.apm.diagnose.feign.client;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.apm.diagnose.feign.AlarmResult;
import com.persagy.apm.diagnose.maintenance.model.dto.QueryAlarmProjectDTO;
import com.persagy.apm.diagnose.service.dto.*;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;


//@FeignClient(name = "dmp-alarm",url = "http://testibmp.scpgroup.com.cn/dmp-alarm")
//@FeignClient(name = "energy-alarm-service",url = "http://develop.persagy.com")
@FeignClient(name = "dmp-alarm")
public interface AlarmServiceClient {


    @PostMapping("/projectAlarmRuleObjRels/query")
    AlarmResult<JSONObject> query(@RequestBody MonitorIndicatorConfigDTO queryMonitorIndicatorConfigDTO) throws Exception;


    @PostMapping("/calculateMethods/query")
    AlarmResult<JSONObject> queryCalculateMethods(@RequestBody CalculateMethodDTO calculateMethodDTO) throws Exception;


    @PostMapping("/projectMonitorIndicatorConfigs/query_by_equip")
    AlarmResult<JSONObject> query_by_equip(@RequestBody MonitorIndicatorConfigByEquipDTO monitorIndicatorConfigByEquipDTO) throws Exception;


    @PostMapping("projectAlarmRules/query_with_indicators_objs")
    AlarmResult<JSONObject> queryProjectAlarmRules(@RequestBody AlarmRuleDTO alarmRuleDTO) throws Exception;


    @PostMapping("/alarmConditions/query_by_obj_and_itemcode")
    AlarmResult<JSONObject> queryByObjAndItemCode(@RequestBody QueryAlarmConditionByObjDTO queryAlarmConditionByObjDTO) throws Exception;

    @PostMapping("pressure_measurement/query_project")
    AlarmResult<JSONArray> queryProject(@RequestBody QueryAlarmProjectDTO queryAlarmProjectDTO) throws Exception;
}
