package com.persagy.apm.diagnose.maintenance.constant;

import com.alibaba.druid.util.StringUtils;

/**
 * 报警条目
 */
public enum EnumAlarmItem {

    EquipmentReplace("Eqgh001", "更换"),
    CondAbnormal("Eqwb001", "冷凝器异常"),
    EvapAbnormal("Eqwb002", "蒸发器异常"),
    CoolTowerApproachTempAbnormal("Eqwb003", "冷却塔逼近温度异常");

    private String code;
    private String name;

    EnumAlarmItem(String code, String name){
        this.code = code;
        this.name = name;
    }

    public String getCode() {
        return code;
    }
    public String getName() {
        return name;
    }

    public void setCode(String code) {
        this.code = code;
    }
    public void setName(String name) {
        this.name = name;
    }

    public static EnumAlarmItem getEnumAlarmLevel(String code) {
        if(StringUtils.isEmpty(code)) {
            return null;
        }
        for(EnumAlarmItem item : EnumAlarmItem.values()) {
            if(item.getCode().equals(code)) {
                return item;
            }
        }
        return null;
    }
}
