package com.persagy.apm.diagnose.maintenance.constant;

import com.alibaba.druid.util.StringUtils;

/**
 * 维保 冷水机组设备类型编码集合
 */
public enum EnumMaintenanceIndicatorType {
    //冷却塔
    ACCCOT_DayAvg("ACCCOT_ApproachTempDayAvg","冷却塔换热端差日维度平均值"),
    ACCCOT_ContinuousOperation("ACCCOT_ApproachTempContinuousOperation","冷却塔持续运行时间"),
    //冷水机组
    ACCCCC_CondHeatTransferDayAvg("ACCCCC_CondHeatTransferDayAvg","冷凝器换热端差日维度平均值阈值"),
    ACCCCC_CondContinuousOperation("ACCCCC_CondContinuousOperation","冷凝器运行持续时间"),
    ACCCCC_EvapHeatTransferDayAvg("ACCCCC_EvapHeatTransferDayAvg","蒸发器换热端差日维度平均值阈值"),
    ACCCCC_EvapContinuousOperation("ACCCCC_EvapContinuousOperation","蒸发器运行持续时间"),


    ACCCSC_CondHeatTransferDayAvg("ACCCSC_CondHeatTransferDayAvg","冷凝器换热端差日维度平均值阈值"),
    ACCCSC_CondContinuousOperation("ACCCSC_CondContinuousOperation","冷凝器运行持续时间"),
    ACCCSC_EvapHeatTransferDayAvg("ACCCSC_EvapHeatTransferDayAvg","蒸发器换热端差日维度平均值阈值"),
    ACCCSC_EvapContinuousOperation("ACCCSC_EvapContinuousOperation","蒸发器运行持续时间"),

    ACCCPC_CondHeatTransferDayAvg("ACCCPC_CondHeatTransferDayAvg","冷凝器换热端差日维度平均值阈值"),
    ACCCPC_CondContinuousOperation("ACCCPC_CondContinuousOperation","冷凝器运行持续时间"),
    ACCCPC_EvapHeatTransferDayAvg("ACCCPC_EvapHeatTransferDayAvg","蒸发器换热端差日维度平均值阈值"),
    ACCCPC_EvapContinuousOperation("ACCCPC_EvapContinuousOperation","蒸发器运行持续时间"),

    ACCCAC_CondHeatTransferDayAvg("ACCCAC_CondHeatTransferDayAvg","冷凝器换热端差日维度平均值阈值"),
    ACCCAC_CondContinuousOperation("ACCCAC_CondContinuousOperation","冷凝器运行持续时间"),
    ACCCAC_EvapHeatTransferDayAvg("ACCCAC_EvapHeatTransferDayAvg","蒸发器换热端差日维度平均值阈值"),
    ACCCAC_EvapContinuousOperation("ACCCAC_EvapContinuousOperation","蒸发器运行持续时间");

    private String code;
    private String name;

    EnumMaintenanceIndicatorType(String code, String name){
        this.code = code;
        this.name = name;
    }

    public String getCode() {
        return code;
    }
    public String getName() {
        return name;
    }

    public void setCode(String code) {
        this.code = code;
    }
    public void setName(String name) {
        this.name = name;
    }

    public static EnumMaintenanceIndicatorType getEnumMaintenanceDataType(String code) {
        if(StringUtils.isEmpty(code)) {
            return null;
        }
        for(EnumMaintenanceIndicatorType item : EnumMaintenanceIndicatorType.values()) {
            if(item.getCode().equals(code)) {
                return item;
            }
        }
        return null;
    }
}
