package com.persagy.apm.diagnose.utils;

/**
 * 湿球温度计算
 */

public class TwdTempUtil {

    public static void main(String[] args) {
        try {
            //Td干球温度 Hr相对湿度 范围 0~100  允许差值 范围
            Double Td = 30.0,Hr = 75.0,limit = 0.1;
            //根据温度和湿度 计算出湿空气焓值
            Double hVal = getHVal(Td,Hr);
            //根据允许范围推出Tw值
            Double newTw = getTw(Td,hVal,limit);
            System.out.println(newTw);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 根据允许范围推出Tw值
     */
    public static Double getTw(Double Td, Double hVal, Double limit){
        Double Tw = Td-3;
        Double num = 0.0;
        Boolean isOk = false;
        Boolean isTrueVal = false;
        Integer zNum = 0,jNum = 0;
        while (!isOk){
            //湿空气焓值
            Double hwVal = getHwVal(Tw);
            //两种湿空气焓值  差值
            Double hc = DataUtils.subtract(hVal,hwVal);
            //判断范围
            if (hc<limit && hc > 0.0){
                isOk = true;
                isTrueVal = true;
            }else if (hc > 0){//hw 小于 h  增加湿球温度数据值
                Tw = Tw + 0.25;
                zNum++;
            }else if (hc < 0){//hw 大于 h  减小湿球温度数据值
                Tw = Tw - 0.25;
                jNum++;
            }
            num++;
            if (num > 20){
                isOk = true;
            }
        }
        if (isTrueVal){
            return Tw;
        }else {
            if (zNum > 0 && jNum > 0){
                return Tw;
            }else{
                return getTw(Td,hVal,limit+0.5);
            }
        }
    }

    /**
     * 根据湿球温度计算出湿空气焓值
     */
    public static double getHwVal(Double Tw){
        Double eVal = (18.678-Tw/234.5)*Tw/(Tw+257.14);
        Double ev= Math.exp(eVal);
        Double Pv = 611.2 * ev; //Td时的水蒸汽饱和压力
        //含湿量
        Double dw = 0.6219*(Pv/(101326-Pv));
        //湿空气焓值
        Double hw = 1.01*Tw + (2500+1.84*Tw)*dw;
        return hw;
    }

    /**
     * 根据温度和湿度 计算出湿空气焓值
     */
    public static double getHVal(Double Td,Double Hr){
        Double eVal = (18.678-Td/234.5)*Td/(Td+257.14);
        Double ev= Math.exp(eVal);
        Double Pv = 611.2*ev; //Td时的水蒸汽饱和压力
        Double hrPv = 0.01*Hr*Pv;
        //含湿量
        Double d = 0.6219*(hrPv/(101326-hrPv));
        //湿空气焓值
        Double h = 1.01*Td + (2500+1.84*Td)*d;
        return h;
    }
}
