package com.persagy.framework.ems.data.pojo.hbase;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.persagy.framework.ems.data.core.annotation.Column;
import com.persagy.framework.ems.data.core.annotation.Dimension;
import com.persagy.framework.ems.data.core.annotation.Entity;
import com.persagy.framework.ems.data.core.annotation.Index;
import com.persagy.framework.ems.data.core.annotation.Table;
import com.persagy.framework.ems.data.core.annotation.TimePatition;
import com.persagy.framework.ems.data.core.enumeration.EMSDimension;
import com.persagy.framework.ems.data.core.enumeration.Schema;
import com.persagy.framework.ems.data.core.enumeration.TimePatitionType;
import com.persagy.framework.ems.data.mvc.pojo.BusinessObject;
import lombok.Data;

@Entity(name = "MonitorIndicatorRecord")
@Table(name = "monitor_indicator", comment = "设备运行诊断指标数据", schema = Schema.UDM,
		indexes = {
				@Index(columns = { "project", "obj_id", "monitor_indicator_id", "data_time"}, unique = true)
})
@Dimension
@TimePatition(column = "data_time", type = TimePatitionType.month)
@Data
public class MonitorIndicatorRecord extends BusinessObject {

	private static final long serialVersionUID = 9123470427203487460L;

	@Column(order = 10, name = "project", length = 20, nullable = false, comment = "项目/建筑id")
	@JsonProperty("project")
	private String project;
	
	@Column(order = 20, name = "obj_id", length = 50, nullable = true, comment = "能耗模型id")
	@JsonProperty("objId")
	private String objId;
	
	@Column(order = 30, name = "monitor_indicator_id", length = 50, nullable = true, comment = "分项id")
	@JsonProperty("monitorIndicatorId")
	private String monitorIndicatorId;


	@Column(order = 40, name = "data_time", length = 0, nullable = false, comment = "数据时间")
	@JsonProperty("dataTime")
	private Date dataTime;

	@Column(order = 50, name = "data_value", length = 28, scale = 8, nullable = false, comment = "数据值")
	@JsonProperty("dataValue")
	private Double dataValue;


}
